#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;
using System.Runtime.Remoting;
using System.Runtime.Serialization;

namespace HeuristicLab.PluginInfrastructure {
  internal class Runner : MarshalByRefObject {

    public void LoadPlugins(ICollection<PluginInfo> plugins) {
      List<string> loadedNames = new List<string>();
      foreach(PluginInfo pluginInfo in plugins) {
        foreach(string assemblyName in pluginInfo.Assemblies) {
          if(!loadedNames.Contains(assemblyName)) {
            Console.WriteLine("Loading assembly " + assemblyName);
            loadedNames.Add(assemblyName);
            Assembly.LoadFrom(assemblyName);
          }
        }
      }
      Console.WriteLine(AppDomain.CurrentDomain.Id);
      PluginManager.Manager.LoadedPlugins = plugins;
    }

    public void Run(string assembly, string type) {
      Console.WriteLine(AppDomain.CurrentDomain.Id);
      object proxy = AppDomain.CurrentDomain.CreateInstanceAndUnwrap(assembly, type);
    }

    // infinite lease time
    public override object InitializeLifetimeService() {
      return null;
    }
  }
}
